<!DOCTYPE html>
<html lang="de-DE">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Suchmaschine - Suche nach <?= (isset($_GET["suchbegriff"]) ? '"' . htmlspecialchars($_GET["suchbegriff"], ENT_HTML5, 'UTF-8') . '"' : ''); ?> </title>
    <link rel="stylesheet" href="./style.css" type="text/css">
</head>

<body>
    <aside id="suchmaschine">
        <?php
        /**
         * PHP Suchmaschine - Suchmaschine für die Artikel und Dateisuche in Webseiten.
         * Version vom: 07.02.2025
         * Copyright (C) 2025 Detlef Paschke
         * Download unter: https://schabau.eu/php-suchmaschine.php
         * 
         * Diese Suchmaschine durchsucht das angegebene Verzeichnis und die enthaltenen Dateien nach dem eingegebenen Suchbegriff
         * rekursiv was heißt, dass untereinander Liegende Verzeichnisse mit durchsucht werden, wenn das jeweils oberste
         * Verzeichnis angegeben wird. Bei Dateien vom  MIME-Type "text/..." (text/html, text/plain...) wird auf der Ergebnisseite
         * in der Regel ein Textausschnitt angezeigt, der das Suchwort enthält. Dateien die nicht vom MIME-Type "text/..." sind,
         * das sind z.B .pdf oder Bilddateien wie .png oder .jpg... werden nur gefunden, wenn im Dateinamen das Suchwort zu finden
         * ist. Bei diesen Dateien wird nur der Dateiname und der Dateityp auf der Ergebnisseite angezeigt.
         * 
         * Für die Funktion der PHP-Suchmaschine wird zwingend PHP 8.0.25 oder höher benötigt und Vorausgesetzt!
         * 
         * Die Suche in PHP-Dateien funktioniert prinzipbedingt derzeit nur rudimentär und nur, wenn die Datei nicht ausschließlich
         *  auf Code beruht sondern z.B. nur eine html-Datei mit unwesentlichen php-Funktionen aber sonst vollständigem Inhalt ist.
         * Die Suche ist auch in Textdateien problemlos möglich, um aber Funktionen wie das Suche in oder Entfernen von Bereichen 
         *  nutzen zu können, müssen die zu durchsuchenden Dateien über gültigen HTML-Code (<title>, <head>, <body>...) verfügen.
         * Bei Dateien die nicht die Zeichenkodierung UTF-8 verwenden, kann eine fehlerhafte Darstellung von Umlauten und 
         *  Sonderzeichen auf der Ergebnisseite nicht ausgeschlossen werden.
         * Lassen Sie nur Verzeichnisse durchsuchen, die keine sensiblen Inhalte haben!
         * 
         * 
         * Dieses Programm ist freie Software. Sie können es unter den Bedingungen der GNU General Public License, wie von der
         * Free Software Foundation veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß Version 3 der Lizenz oder
         * (nach Ihrer Option) jeder späteren Version.
         * 
         * Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE
         * GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Details
         * finden Sie in der GNU General Public License.
         * 
         * Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben.
         * Falls nicht, siehe <http://www.gnu.org/licenses/>.
         */

        /* Hier die zu durchsuchenden Verzeichnisse eintragen, ausgehend vom aktuellen Verzeichnis in dem die Suchmaschine liegt.
        Die Suche erfolgt recursive, untereinander liegende Verzeichnisse müssen nicht einzelnen aufgeführt werden. Bei parallel
        liegenden Verzeichnissen jeweils das oberste gewünschte Verzeichnis angeben. Aktuelles Verzeichnis durchsuchen mit "./" */
        $verzeichnisse = [
            //    "./",
            "./daten",
        ];

        /* Unterverzeichnisse wie z.B. Arbeits- oder Testverzeichnisse die von der Suche ausgeschlossen werden sollen, hier angeben.
        Der Ausschluss ist recursive, untereinander liegende Verzeichnisse werden auch Ausgeschlossen. (Pfad ohne "/" am Ende!) */
        $ausschluss_verzeichnis = [
            "./daten/arbeit",
            //    "./daten/arbeit2",
        ];

        /* Dateiendungen der Dateien, die gesucht werden sollen. Bei Nichttext-Dateien (.pdf, .jpg, .png...) wird auf der
        Ergebnisseite nur der Dateiname und Dateityp angegeben. Es können bei Bedarf weitere Dateitypen hinzugefügt werden. */
        $dateiendungen = [
            ".html",
            //    ".htm",
            //    ".php",
            //    ".txt",
            ".pdf",
            //    ".gif",
            //    ".jpg",
            //    ".png",
        ];

        /* Vorzeichen von Dateien die nicht durchsucht werden sollen. _intern.htm oder .login.php (nur das 1. Zeichen) */
        $vorzeichen = [
            //    ".",
            //    "_",
        ];

        /* Einzelne Dateien die nicht durchsucht werden sollen. */
        $nicht_durchsuchen = [
            //    "privat.htm",
            //    "login.php",
        ];

        /* Minimal nötige Länge des Suchbegriff. */
        $suchbegriff_min = 3; // 3

        /* Maximal erlaubte Länge des Suchbegriff. */
        $suchbegriff_max = 50; // 100

        /* Maximal angezeigte Ergebnisse je Suche. */
        $suchergebnisse_max = 50; // 50

        /* Die Suchergebnisse in einzelne Seiten aufteilen und wie viele Ergebnisse pro Seite anzeigen? (ja/nein) */
        $ergebnisseiten = "nein"; // nein
        $fund_seite = 5; // 5

        /* Unerwünschte Eingaben von der Suche ausschließen */
        $ausschluss_eingaben = [
            //    "Demotext",
            //    "Demotext2",
        ];

        /* Automatische Weiterleitung und Wartezeit in Sekunden wenn nur eine Datei gefunden wurde? (ja/nein) */
        $auto_weiterleitung = "ja"; // ja
        $sekunden_weiterleitung = 5; // 5

        /* Ziel mit _blank in neuem Fenster/Tab oder mit _self im selben Fenster/Tab öffnen? Verwendet man unterschiedliche
        iFrame für Eingabefeld und Suchergebnis, kann "_top" oder "_parent" verwendet werden. */
        $target = "_self"; // leer oder _self

        /* Tipps anzeigen wenn nichts gefunden wurde? (ja/nein) */
        $tipps_anzeigen = "ja"; // ja

        /* Die Ergebnisse nach der letzten Dateiänderung (Datum) oder nach der Anzahl der gefundenen Ergebnisse pro Seite
        sortieren? (ja/nein). */
        $sortierung_dateiaenderung = "nein"; // nein

        /* Ergebnis der Suche (Datum, IP, Hostname, Suchanfrage und Trefferzahl) in eine Datei speichern? (ja/nein) */
        $sucheingabe_speichern = "nein"; // nein

        /* Name der Datei in der die Auswertung gespeichert werden sollen. Diese Datei wird beim ersten Eintrag
        automatisch erzeugt. */
        $suchdatei = "suchmaschine_auswertung.txt"; // suchmaschine_auswertung.txt

        /* Die Ergebnisse der Sucheingabe zusätzlich in einer .html Datei speichern? Der Dateiname wird aus der Angabe in
        $suchdatei übernommen. */
        $suchdatei_html = "nein"; // nein

        /* Die 5 häufigsten Sucheingaben als Auswahl, im Formularfeld anzeigen? (ja/nein) Das Funktioniert nicht, wenn das
        Formularfeld in einem anderen iFrame angezeigt wird, außerdem muss "$sucheingabe_speichern" auf "ja" stehen! */
        $datenliste_anzeigen = "nein"; // nein

        /* Datei-Info wie letzte Änderung und Dateigröße als Info unter jedem Ergebnis anzeigen? (ja/nein) */
        $datei_info = "ja"; // ja

        /* Dateipfad zusätzlich in Datei-Info anzeigen? (ja/nein) Datei-Info muss aktiviert sein! */
        $pfad_info = "ja"; // ja

        /* Status-Info also die Anzahl der durchsuchten Dateien und Verzeichnisse am Ende der Ergebnisseite anzeigen? (ja/nein) */
        $status_info = "ja"; // ja

        /* Die Länge des angezeigten Textausschnitts auf der Ergebnisseite. */
        $textausschnitt = 180; // 180 Zeichen

        /* Treffer auf der Ergebnisseite und verlinkten Zielseite farblich markieren? (ja/nein) Dies wird evtl. nicht
            von allen Browsern unterstützt! */
        $treffer_hervorheben = "ja"; // ja

        /* Inhalt entfernen der zwischen den folgenden HTML-Tags liegt. Dieser Inhalt wird nicht in der Suche berücksichtigt. */
        $entfernung_inhalt = [
            //    "h1", // <h1></h1>
            //    "nav", // <nav></nav>
            //    "head", // <head></head>
            //    "footer", // <footer></footer>
        ];

        /* Einen bestimmten HTML-Bereich für die Suche definieren z.B.: body, main oder article. Leer lassen wenn diese Option
        nicht verwendet werden soll. */
        $suche_in_bereich = "";

        /* META-Tags anzeigen, wenn diese vorhanden sind? (ja/nein) */
        $metatags_anzeigen = "ja"; // ja

        /* Nur diese META-Tags anzeigen oder ohne Auswahl werden alle META-Tags angezeigt. */
        $metatags_anzeigebereiche = [
            "author",
            "description",
            //    "keywords",
            //    "application-name",
        ];

        /* META-Tags in die Suche einschließen? (ja/nein) */
        $metatags_durchsuchen = "ja"; // ja

        /* Nur diese META-Tags durchsuchen oder ohne Auswahl werden alle META-Tags durchsucht. */
        $metatags_suchbereiche = [
            //    "author",
            //    "description",
            "keywords",
            //    "application-name",
        ];

        /* Zeitzone setzen (siehe: http://php.net/manual/de/timezones.europe.php) */
        date_default_timezone_set("Europe/Berlin");

        /* PHP-Fehlermeldungen anzeigen? (0/E_ALL) */
        error_reporting(0); // 0

        /* PHP-Version auf dem System überprüfen. */
        if (version_compare("8.0.25", PHP_VERSION, ">")) {
            die("PHP 8.0.25 or greater is required!!!");
        }

        // Daten für Suchdatei und Datenliste sammeln.
        $remoteip = $_SERVER["REMOTE_ADDR"];
        $remotehost = ($remoteip !== gethostbyaddr($_SERVER['REMOTE_ADDR'])) ? gethostbyaddr($_SERVER['REMOTE_ADDR']) : 'Fehler!';
        $datenliste = "";
        if (
            $sucheingabe_speichern == "ja" &&
            $datenliste_anzeigen == "ja" &&
            file_exists($suchdatei)
        ) {
            $datenliste = [];
            foreach (file($suchdatei, FILE_SKIP_EMPTY_LINES | FILE_IGNORE_NEW_LINES) as $element) {
                list($datum, $remoteip, $remotehost, $suchbegriff_raw, $suchbegriff, $anzahl) = explode(' | ', $element);
                if ($anzahl > 0) {
                    $datenliste[] = $suchbegriff;
                }
            }
            array_shift($datenliste);
            $datenliste = array_count_values($datenliste);
            arsort($datenliste);
            $datenliste = '<datalist id="liste"><option>' . implode('<option>', array_slice(array_keys($datenliste), 0, 5)) . '</datalist>';
        }

        // Formular anzeigen
        echo '<form method="get" action="">' . ($ergebnisseiten == "ja" ? '<input type="hidden" name="page" value="1">' : '') .
            '<input id="suchmaschine_suchbegriff" type="search" name="suchbegriff" placeholder="Suchbegriff eingeben" value="' .
            (isset($_GET["suchbegriff"]) ? htmlspecialchars($_GET["suchbegriff"], ENT_HTML5, 'UTF-8') : '') . '" size="35" minlength="' .
            $suchbegriff_min . '" maxlength="' . $suchbegriff_max . '" list="liste" required="required" spellcheck="true">' . $datenliste . '
            <input type="submit" name="suche" value="suchen"></form>';

        $suchergebnisse = [];
        $gefunden = 0;
        $anzahl_dateien = 0;
        $hyperlink = "";
        $directories = [];
        $filter = '/\.(?:' . str_replace(".", "", implode("|", $dateiendungen)) . ')$/i';
        $startzeit = microtime(true);
        $url = $_SERVER["REQUEST_SCHEME"] . '://' . $_SERVER["HTTP_HOST"] . (dirname($_SERVER["SCRIPT_NAME"]) == '/' ? '' : dirname($_SERVER["SCRIPT_NAME"])) . '/';
        array_push($nicht_durchsuchen, basename($_SERVER["SCRIPT_NAME"]));

        if (
            isset($_GET["suche"]) ||
            isset($_GET["suchbegriff"])
        ) {

            // Tabulator und Leerzeichen für die Suchdatei im utf-8 Format, in sichtbare Zeichen umwandeln.
            $suchbegriff_raw = preg_replace(['/(\t)/', '/(\s+)/'], ["\u{2192}", "\u{b7}"], $_GET["suchbegriff"]);

            // Sonderzeichen, überflüssige Leerzeichen, Tabulatoren und unerwünschte Worte aus Suchanfrage entfernen.
            $_GET["suchbegriff"] = rawurldecode($_GET["suchbegriff"]);
            $_GET["suchbegriff"] = trim(preg_replace(['/(\"|\'|\\\|\/|\?|\!|\,|\;|\:)/', '/(\s\s+|\t)/'], ' ', $_GET["suchbegriff"]));
            foreach ($ausschluss_eingaben as $ausschluss) {
                if (mb_strtolower($_GET["suchbegriff"]) == mb_strtolower($ausschluss)) {
                    echo '<p>Die Suchanfrage <i>' . $_GET["suchbegriff"] . '</i> ist unerwünscht und wird verworfen.</p>';
                    $_GET["suchbegriff"] = trim(($_GET["suchbegriff"]), "\x00..\xFF");
                }
            }

            // Prüfen ob die Suchanfrage aus mehr als einem Wort besteht. (Wird für die Tipps und Regex-Suche benötigt.)
            $preg = preg_split('/(\s+|_|-)/', $_GET["suchbegriff"]);
            $pregReg = implode("\W{1,3}", array_values($preg));
            $pregCount = count($preg);

            if (
                mb_strlen($_GET["suchbegriff"]) >= $suchbegriff_min &&
                mb_strlen($_GET["suchbegriff"]) <= $suchbegriff_max
            ) {

                // Verzeichnis öffnen, Verzeichnis- und Dateifilter anwenden und Dateien einlesen.
                foreach ($verzeichnisse as $verzeichnis) {
                    $dir = new RecursiveDirectoryIterator($verzeichnis, FilesystemIterator::UNIX_PATHS);
                    $dirfilter = new RecursiveCallbackFilterIterator($dir, function ($file, $key, $iterator) use ($ausschluss_verzeichnis) {
                        if ($iterator->hasChildren() && !in_array($file->getPathname(), $ausschluss_verzeichnis)) {
                            return true;
                        }
                        return $file->isFile();
                    });
                    $dateifilter = new RegexIterator(new RecursiveIteratorIterator($dirfilter), $filter);

                    foreach ($dateifilter as $zeiger) {
                        if ($zeiger->isFile()) {
                            $datei = $zeiger->getPathname();
                            $dateiname = $zeiger->getBasename();
                            $dateiendung = '.' . $zeiger->getExtension();

                            if (!in_array(dirname($zeiger->getPathname()), $directories)) {
                                $directories[] = dirname($zeiger->getPathname());
                            }

                            if (
                                !in_array(substr($dateiname, 0, 1), $vorzeichen) &&
                                !in_array($dateiname, $nicht_durchsuchen)
                            ) {

                                // Reset der (vorherigen) Suche.
                                $string = false;
                                $regex = false;
                                $file = false;

                                // Text aus Dateien einlesen und bei nichttext Dateien den Dateityp als Text angeben.
                                $text = str_starts_with(mime_content_type($datei), 'text') ? file_get_contents($datei) : mb_substr(strtoupper($dateiendung), 1) . '-Datei';
                                preg_match('/<title>(.*?)<\/title>/is', $text, $treffer);
                                $titel = isset($treffer[1]) ? $treffer[1] : $dateiname;
                                unset($treffer[1]);
                                $anzahl_dateien++;

                                // META-Tags für die Anzeige und Suche auslesen.
                                if ($metatags_anzeigen == "ja" && count(get_meta_tags($datei)) > 0) {
                                    $metatags_anzeige = get_meta_tags($datei);
                                    if (count($metatags_anzeigebereiche) > 0) {
                                        foreach ($metatags_anzeige as $name => $content) {
                                            if (!in_array($name, $metatags_anzeigebereiche)) {
                                                unset($metatags_anzeige[$name]);
                                            }
                                        }
                                    }
                                    $meta_anzeige = '<br><cite id="suchmaschine">&diams; ' . implode(' &diams; ', $metatags_anzeige) . '</cite>';
                                } else {
                                    $meta_anzeige = '';
                                }
                                if ($metatags_durchsuchen == "ja" && count(get_meta_tags($datei)) > 0) {
                                    $metatags_suche = get_meta_tags($datei);
                                    if (count($metatags_suchbereiche) > 0) {
                                        foreach ($metatags_suche as $name => $content) {
                                            if (!in_array($name, $metatags_suchbereiche)) {
                                                unset($metatags_suche[$name]);
                                            }
                                        }
                                    }
                                    $meta_suche = ' [' . implode(" \u{2666} ",  $metatags_suche) . ']';
                                } else {
                                    $meta_suche = '';
                                }

                                // Ausschlüsse und nicht zu durchsuchende Bereiche entfernen.
                                if (!empty($suche_in_bereich)) {
                                    preg_match('/<' . $suche_in_bereich . '>(.*?)<\/' . $suche_in_bereich . '>/Uis', $text, $bereich);
                                    $text = isset($bereich[1]) ? $bereich[1] : '';
                                }
                                foreach ($entfernung_inhalt as $htmltag) {
                                    $text = preg_replace('/\<' . $htmltag . '\>(.*)\<\/' . $htmltag . '\>/Uis', '', $text);
                                }

                                // Textausschnitt für die Ergebnisseite vorbereiten.
                                $textteil = preg_replace('/<title>(.*?)<\/title>/is', '', $text);
                                $textteil = strip_tags(html_entity_decode($textteil));
                                $textteil = trim(preg_replace(['/\s\s+/', '/\t/'], ' ', $textteil));

                                // HTML-Tags, multiple Leerzeichen und Tabulatoren aus dem Suchtext entfernen.
                                $text = strip_tags(html_entity_decode($text));
                                $text = trim(preg_replace(['/\s\s+/', '/\t/'], ' ', $text));
                                if ($metatags_durchsuchen == "ja") {
                                    $text .= $meta_suche;
                                }

                                // Suche durchführen und Treffer erfassen.
                                if (
                                    ($string = mb_stristr($text, $_GET["suchbegriff"],) ? true : false or
                                        $regex = preg_match_all("/" . $pregReg . "/is", $text, $regmatch, PREG_PATTERN_ORDER) ? true : false or
                                        $file = preg_match_all("/" . $pregReg . "/is", $dateiname, $filematch, PREG_PATTERN_ORDER) ? true : false) &&
                                    $gefunden <= $suchergebnisse_max
                                ) {
                                    $gefunden++;
                                    $treffer = (($string === true ? mb_substr_count(mb_strtolower($text), mb_strtolower($_GET["suchbegriff"])) : 0) +
                                        ($regex === true ? count($regmatch[0]) : 0) + ($file === true ? count($filematch[0]) : 0));
                                    $hyperlink = $link = $url . preg_replace('/(\.\.?\/)/', '', $datei);

                                    /* Textausschnitt für die Ergebnisseite erstellen. Die Position muss unterschiedlich ermittelt werden,
                                    damit auf der Ergebnisseite der richtige Textausschnitt angezeigt wird. */
                                    if ($string === true) {
                                        $textpos = array([$_GET["suchbegriff"], mb_stripos($textteil, $_GET["suchbegriff"])]);
                                    } elseif ($regex === true) {
                                        preg_match("/" . $pregReg . "/is", $textteil, $textpos, PREG_OFFSET_CAPTURE);
                                    } elseif ($file === true) {
                                        $textpos = array([$filematch[0][0], 0]);
                                    }
                                    $start = ($textpos[0][1]) - intdiv($textausschnitt, 3);
                                    if ($start < 0)
                                        $start = 0;
                                    $textteil = ($string === true ? mb_substr($textteil, $start, $textausschnitt) : mb_strcut($textteil, $start, $textausschnitt));

                                    // Hervorheben des Suchwort auf der Ergebnisseite und im Hyperlink.
                                    if ($treffer_hervorheben == "ja") {
                                        $worte = [$textpos[0][0]];
                                        foreach ($worte as $wort) {
                                            $titel = preg_replace('/(' . preg_quote($wort, '/') . ')/i', "<mark id='suchmaschine'>$1</mark>", $titel);
                                            $textteil = preg_replace('/(' . preg_quote($wort, '/') . ')/i', "<mark id='suchmaschine'>$1</mark>", $textteil);
                                            $link = preg_replace('/(' . preg_quote($wort, '/') . ')/i', "<mark id='suchmaschine'>$1</mark>", $link);
                                            $hyperlink = $hyperlink . '#:~:text=' . rawurlencode($wort);
                                        }
                                    }

                                    $suchergebnisse[($sortierung_dateiaenderung == "ja" ? date("Y-m-d H:i:s", filemtime($datei)) : sprintf("%02s", $treffer) . sprintf("%02s", $gefunden))] =
                                        '<li id="suchmaschine"><a href="' . $hyperlink . '" target="' . $target . '">' . $titel . '</a> <small>(' . $treffer . 'x)</small>' . $meta_anzeige . '<br><samp id="suchmaschine">&hellip; ' . $textteil . ' &hellip;</samp>' . ($datei_info == "ja" ? '<br><var  id="suchmaschine">Letzte Änderung: ' . date("d.m.Y H:i", filemtime($datei)) . ' - ' . number_format((filesize($datei) / 1024), 1, ",", ".") . ' KB' . ($pfad_info == "ja" ? ' - ' . $link : '') . '</var>' : '') . '</li>';
                                }
                            }
                        }
                    }
                }

                // Doppelungen in den Suchergebnissen entfernen. (Wenn fehlerhaft untereinander liegende Verzeichnisse angegeben werden.)
                $suchergebnisse = array_unique($suchergebnisse);
                if (count($suchergebnisse) != $gefunden) {
                    $gefunden = count($suchergebnisse);
                }

                // Ergebnisse der Suche sortieren.
                krsort($suchergebnisse);

                // Ergebnisseite mit Abschnitten erstellen.
                if ($ergebnisseiten == "ja" && $gefunden > 1) {
                    $fund = 0;
                    if ($fund_seite < 1) {
                        $fund_seite = 1;
                    }

                    foreach ($suchergebnisse as $key => $ergebnis) {
                        $fund++;
                        if ($key === array_key_first($suchergebnisse)) {
                            $ergebnis_seiten = '[page]' . $ergebnis;
                        } elseif ($key === array_key_last($suchergebnisse)) {
                            $ergebnis_seiten .= $ergebnis . '[/page]';
                        } else {
                            $ergebnis_seiten .= (($fund % $fund_seite === 0) ? $ergebnis . '[/page][page]' : $ergebnis);
                        }
                    }

                    preg_match_all('/\[page](.*)\[\/page]/Uis', $ergebnis_seiten, $pagematch);
                    $page = isset($_GET["page"]) ? (int)$_GET["page"] : 1;
                    if ($page < 1) {
                        $page = 1;
                    }
                    if ($page > count($pagematch[0])) {
                        $page = count($pagematch[0]);
                    }

                    $getCopy = $_GET;
                    unset($getCopy["page"]);
                    $getCopy = http_build_query($getCopy);

                    $nav = '<table style="overflow-x: auto; display: block; width: fit-content; margin-left: auto; margin-right: auto;">
                        <tr><td style="text-align:left; width: 80px;">';
                    if ($page > 1) {
                        $nav .= '<a href="' . $_SERVER["PHP_SELF"] . '?page=' . ($page - 1) . '&' . $getCopy . '">&#8678; Zurück</a>';
                    } else {
                        $nav .= '</td>';
                    }
                    $nav .= '<td style="width: fit-content;">Seite: ';
                    for ($i = 1; $i <= count($pagematch[0]); $i++) {
                        if ($i == $page) {
                            $nav .= $i . ' ';
                        } else {
                            $nav .= '<a href="' . $_SERVER["PHP_SELF"] . '?page=' . $i . '&' . $getCopy . '">' . $i . '</a> ';
                        }
                    }
                    $nav .= '</td><td style="text-align:right; width: 80px;">';
                    if ($page < count($pagematch[0])) {
                        $nav .= '<a href="' . $_SERVER["PHP_SELF"] . '?page=' . ($page + 1) . '&' . $getCopy . '">Weiter &#8680;</a>';
                    } else {
                        $nav .= '</td>';
                    }
                    $nav .= '</tr></table>';
                    $suchergebnisse = $pagematch[1][$page - 1];
                } else {
                    $suchergebnisse = implode($suchergebnisse);
                }

                // Ergebnis der Suche in Datei speichern.
                if ($sucheingabe_speichern == "ja") {
                    $filenew = fopen($suchdatei, "c");
                    fputs($filenew, "Datum und Uhrzeit | Remote-IP | Remote-Hostname | Suchbegriff_raw | Suchbegriff | Trefferanzahl\n" . "\n");
                    fclose($filenew);
                    $fileedit = fopen($suchdatei, "a+");
                    fputs($fileedit, date("d.m.Y H:i:s") . ' | ' . $remoteip . ' | ' . $remotehost . ' | ' . $suchbegriff_raw . ' | ' . htmlspecialchars($_GET["suchbegriff"], ENT_HTML5, 'UTF-8') . ' | ' . $gefunden . "\n");
                    fclose($fileedit);

                    // Ergebnisse der Suche zusätzlich in einer html Datei speichern.
                    if ($sucheingabe_speichern == "ja" && $suchdatei_html == "ja") {
                        $html_suchdatei = fopen((pathinfo($suchdatei, PATHINFO_FILENAME)) . ".html", "w");
                        fputs(
                            $html_suchdatei,
                            "<!DOCTYPE html>
<html lang='de-DE'>

<head>
    <meta http-equiv='content-type' content='text/html; charset=utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1.0'>
    <title>" . pathinfo($suchdatei, PATHINFO_FILENAME) . "</title>
    <meta name='robots' content='noindex,nofollow'>
    <style>
        html,
        body {
            height: 100%;
            width: 100%;
            font-size: 16px;
            scroll-behavior: smooth;
        }

        table,
        th,
        td {
            border: 1px solid Brown;
            border-collapse: collapse;
            padding: 2px 5px;
        }

        .marker {
            color: SandyBrown;
        }
    </style>
    <script type='text/javascript'>
        window.onload = function () {
            document.body.innerHTML = document.body.innerHTML
                .replaceAll('\u{b7}', '<span class=\"marker\">\u{b7}</span>')
                .replaceAll('\u{2192}', '<span class=\"marker\">\u{2192}</span>');
        }
    </script>
</head>
<body>
    <table>"
                        ); // Kopfzeile erstellen.
                        $zeilen = file($suchdatei, FILE_SKIP_EMPTY_LINES | FILE_IGNORE_NEW_LINES);
                        $kopf = array_shift($zeilen);
                        $k = explode("|", $kopf);
                        fputs(
                            $html_suchdatei,
                            " <thead>
            <tr>
                <th>$k[0]</th>
                <th>$k[1]</th>
                <th>$k[2]</th>
                <th>$k[3]</th>
                <th>$k[4]</th>
                <th>$k[5]</th>
            </tr>
        </thead>
        <tbody>"
                        ); // Datenzeilen erstellen.
                        foreach ($zeilen as $zeile) {
                            $d = explode("|", $zeile);
                            fputs($html_suchdatei, " <tr>
                <td>$d[0]</td>
                <td>$d[1]</td>
                <td>$d[2]</td>
                <td>" . htmlentities($d[3], ENT_HTML5 | ENT_QUOTES, 'UTF-8') . "</td>
                <td>$d[4]</td>
                <td>$d[5]</td>
            </tr>");
                        }
                        fputs($html_suchdatei, " </tbody>
    </table>
</body>

</html>");
                        fclose($html_suchdatei);
                    }
                }

                // Keine Übereinstimmung gefunden.
                if ($gefunden == 0) {
                    echo '<p>Es wurden keine Übereinstimmungen bei der Suche nach <i>' . htmlspecialchars($_GET["suchbegriff"], ENT_HTML5, 'UTF-8') . '</i> gefunden.</p>';
                    // Tipps anzeigen.
                    if ($tipps_anzeigen == "ja") {
                        echo '<p>Bitte achten Sie auf die Rechtschreibung';
                        if (isset($pregCount) && $pregCount > 1) {
                            echo ' und verwenden Sie wenn möglich nur einen einzelnen Suchbegriff';
                        }
                        echo '!</p>';
                    }
                } else {
                    // Automatische Weiterleitung bei nur einer Übereinstimmung.
                    if ($auto_weiterleitung == "ja" && $gefunden == 1) {
                        exit('<p>Es wurde nur eine Datei bei der Suche nach <i> ' . $_GET["suchbegriff"] . '</i> gefunden.</p>
                            <p>Die Datei wird in ' . $sekunden_weiterleitung . ' Sekunden automatisch geladen...</p><ol>' . $suchergebnisse . '</ol><meta http-equiv="refresh" content="' . $sekunden_weiterleitung . '; URL=' . $hyperlink . '"></aside></body></html>');
                    }
                    // Ausgabe der Suchergebnisse.
                    echo '<p>Es ' . ($gefunden == 1 ? 'wurde ' . $gefunden . ' Datei' : 'wurden ' . $gefunden . ' Dateien') . ' bei der Suche nach <i>' . htmlspecialchars($_GET["suchbegriff"], ENT_HTML5, 'UTF-8') . '</i> gefunden.</p>' . '<ol start="' . ($ergebnisseiten == "ja" && $gefunden > 1 ? (($page - 1) * $fund_seite + 1) : 1) . '">' . $suchergebnisse . '</ol>' . ($ergebnisseiten == "ja" && $gefunden > 1 && count($pagematch[0]) > 1 ? $nav : '');
                }
                // Status-Info anzeigen.
                if ($status_info == "ja") {
                    printf('<p>In %.2f Sekunden ' . (count($directories) == 1 ? 'wurde ' . count($directories) . ' Verzeichnis mit ' : 'wurden ' . count($directories) . ' Verzeichnisse mit ') . $anzahl_dateien . ($anzahl_dateien == 1 ? ' Datei ' : ' Dateien ') . 'durchsucht.</p>', microtime(true) - $startzeit);
                }
            }
            // Länge des Suchbegriffs zu kurz/zu lang.
            else {
                echo '<p>Der Suchbegriff ' . (mb_strlen($_GET["suchbegriff"]) < $suchbegriff_min ? 'muss mindestens ' . $suchbegriff_min . ' Zeichen haben' : 'darf maximal ' . $suchbegriff_max . ' Zeichen haben') . '!</p>';
            }
        }
        ?> </aside>
</body>

</html>